/*		JPAARealTimePackage enables Modelica models to run in real time in Dymola IDE. The Dymola Real Time option is not needed.</p>
	*
	*	Author:
	*
	*	Florian Wagner	
	*	TU Kaiserslautern
	*	FB EIT, JPA
	*	Erwin-Schrdinger-Str. 12
	*	67663 Kaiserslautern
	*	Germany
	*	eMail: wagner@eit.uni-kl.de
	*	WWW: http://www.eit.uni-kl.de/frey
	*
	*
	*	Copyright holder:
	*	
	*	TU Kaiserslautern<br>
	*	FB EIT, JPA<br>
	*	Erwin-Schrdinger-Str. 12<br>
	*	67663 Kaiserslautern<br>
	*	Germany
	*
	*
	*	License and Copyright:
	*
	*	Copyright (c) 2007 TU Kaiserslautern, FB EIT, JPA
	*
	*	Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the \"Software\"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:
	*	The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.
	*	THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
	*/


#include "TimerAccess.h"
#include "windows.h"
#include "time.h"

LARGE_INTEGER InitialTime;
LARGE_INTEGER Frequency;
LARGE_INTEGER CurrentTime;
	
/*	@brief	Method to retrieve information about mainboard hardware timer
*	@param	none
*	@return	none
*/
void init()
{
	QueryPerformanceFrequency(&Frequency);
	QueryPerformanceCounter(&InitialTime);
}

/*	@brief	Method to get the elapsed time in seconds since last reset of timer
*	@param	none
*	@return	elapsed time in s
*/
double getTime()
{	
	QueryPerformanceCounter(&CurrentTime);

	return ((double)(CurrentTime.QuadPart-InitialTime.QuadPart))/Frequency.QuadPart;
}

/*	@brief Method to pause the application. This is a wrapper function for Sleep() of timer.h
*	@param numer of milliseconds to pause
*	@return	none
*/
void sleep(int ms)
{
	Sleep(ms);
}